;################################################################################
;#										#
;# copyright (c) 2012-2013 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;# This library is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public				#
;# License as published by the Free Software Foundation; either			#
;# version 3 of the License, or (at your option) any later version.		#
;#										#
;# This library is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

.set	ctype = 8
.include "config.inc"

.if ctype == 8
	.include "/usr/local/include/avr/m8def.inc"
.endif
.if ctype == 88
	.include "/usr/local/include/avr/m88def.inc"
.endif

.def	const_0 = r2
.def	const_1 = r3
.def	tempreg1 = r20
.def	tempreg2 = r21
.def	tempreg3 = r22
.def	tempreg4 = r23
.def	block = r24
.def	element = r25
.def	variable = r19
.def	first_vert = r18
.def	count_l = r4
.def	count_h = r5
.def	precount = r6
.def	disp_count = r7
.def	disp_neg = r9
.def	disp_d0 = r10
.def	disp_d1 = r11

.include "macros.inc"

.equ		sys_var = 0x100
.equ		prog_num = sys_var + 1
.equ		channel_pwm = sys_var + 2
.equ		channel_out = sys_var + 8
.equ		tone_acc_l = sys_var + 9
.equ		tone_acc_h = sys_var + 10
.equ		tone_num = sys_var + 11
.equ		sub_ele = sys_var + 12
.equ		sub_fvert = sys_var + 13
.equ		sub_var = sys_var + 14
.equ		sys_rand1 = sys_var + 16
.equ		sys_rand2 = sys_var + 17
.equ		sys_rand3 = sys_var + 18
.equ		sys_rand4 = sys_var + 19
.equ		cal_mot1l = sys_var + 20
.equ		cal_mot1h = sys_var + 21
.equ		cal_mot2l = sys_var + 22
.equ		cal_mot2h = sys_var + 23
.equ		autostart = sys_var + 24
.equ		sub_r14 = sys_var + 25
.equ		sub_r15 = sys_var + 26
.equ		sub_fv = sys_var + 27
.equ		aux_var1 = sys_var + 28
.equ		aux_var2 = sys_var + 29


.org 0x0000
		rjmp	start
.if ctype == 8
	.org OC2ADDR
.endif
.if ctype == 88
	.org OC2AADDR
.endif
		rjmp	sys_int

.org 0x0080
		.db 0x00,0x00		;force erase of autostart
.org 0x0100
prog_1:		.db "leeres Programm",0
		.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		.db 0x02,0x00,0xff,0xff,0x18,0xff
.org prog_1+(7*16)
		.db 0,04,0x00,0x01,0xff,0x24,0x00,0x05,0x00,0xff,0xff,0x2f
.org prog_1+(13*16)
		.db 0,04,0x00,0x01,0xff,0x24,0x00,0x05,0x00,0xff,0xff,0x2f
.org prog_1+(19*16)
		.db 0,04,0x00,0x01,0xff,0x24,0x00,0x05,0x00,0xff,0xff,0x2f
.org prog_1+(25*16)
		.db 0,04,0x00,0x01,0xff,0x24,0x00,0x05,0x00,0xff,0xff,0x2f

.org 0x0300
prog_2:		.db "leeres Programm",0
		.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		.db 0x02,0x00,0xff,0xff,0x18,0xff
.org prog_2+(7*16)
		.db 0,04,0x00,0x01,0xff,0x24,0x00,0x05,0x00,0xff,0xff,0x2f
.org prog_2+(13*16)
		.db 0,04,0x00,0x01,0xff,0x24,0x00,0x05,0x00,0xff,0xff,0x2f
.org prog_2+(19*16)
		.db 0,04,0x00,0x01,0xff,0x24,0x00,0x05,0x00,0xff,0xff,0x2f
.org prog_2+(25*16)
		.db 0,04,0x00,0x01,0xff,0x24,0x00,0x05,0x00,0xff,0xff,0x2f

.org 0x0500
prog_3:		.db "leeres Programm",0
		.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		.db 0x02,0x00,0xff,0xff,0x18,0xff
.org prog_3+(7*16)
		.db 0,04,0x00,0x01,0xff,0x24,0x00,0x05,0x00,0xff,0xff,0x2f
.org prog_3+(13*16)
		.db 0,04,0x00,0x01,0xff,0x24,0x00,0x05,0x00,0xff,0xff,0x2f
.org prog_3+(19*16)
		.db 0,04,0x00,0x01,0xff,0x24,0x00,0x05,0x00,0xff,0xff,0x2f
.org prog_3+(25*16)
		.db 0,04,0x00,0x01,0xff,0x24,0x00,0x05,0x00,0xff,0xff,0x2f

.org 0x0700
prog_4:		.db "leeres Programm",0
		.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		.db 0x02,0x00,0xff,0xff,0x18,0xff
.org prog_4+(7*16)
		.db 0,04,0x00,0x01,0xff,0x24,0x00,0x05,0x00,0xff,0xff,0x2f
.org prog_4+(13*16)
		.db 0,04,0x00,0x01,0xff,0x24,0x00,0x05,0x00,0xff,0xff,0x2f
.org prog_4+(19*16)
		.db 0,04,0x00,0x01,0xff,0x24,0x00,0x05,0x00,0xff,0xff,0x2f
.org prog_4+(25*16)
		.db 0,04,0x00,0x01,0xff,0x24,0x00,0x05,0x00,0xff,0xff,0x2f

.org 0x0900
start:		cli
		ldi	XL,LOW(RAMEND)
		out	SPL,XL
		ldi	XL,HIGH(RAMEND)
		out	SPH,XL
		clr	const_0
		clr	const_1
		inc	const_1
		out	DDRD,const_0
		out	PORTD,const_0


		;check autostart
		sts	autostart,const_0	;disable autostart
		in	ZL,MCUSR
		sbrc	ZL,0			;skip if not POR
		sts	autostart,const_1	;enable autostart if reset was POR
		out	MCUSR,const_0		;clear POR bit
		ldi	ZL,0x00			;memory block with autostart byte
		ldi	ZH,0x01
		lpm	ZL,Z
		sbrs	ZL,0			;skip erasing if already erased
		rcall	mem_perase
		out	DDRD,const_0		;display port as input
		out	PORTD,const_0		;disable pull-ups
		ldi	XL,0xff
		out	PORTB,XL

		;invert display signals
		clr	XL			;display inverter
		sbic	PIND,7
		ldi	XL,0x7f
		mov	disp_neg,XL
		out	PORTD,disp_neg

		rcall	clr_segm		;clear all segment
		ldi	XL,0xff
		out	DDRD,XL			;set segm to output
		out	DDRC,const_0		;PORTC = input (sig 1-6)

;-------------------------------------------------------------------------------
; check default program and replace with defaults if necessary
;-------------------------------------------------------------------------------
start_def:	ldi	YL,1			;get selected program
		ldi	YH,0
		libeep_read
		cpi	tempreg1,0x04
		brcs	start_def1		;is valid
		clr	tempreg1		;set invalid program to P1
		ldi	YL,1			;get selected program
		ldi	YH,0
		libeep_write
start_def1:

;-------------------------------------------------------------------------------
; check calibration data for motor 1 and replace with defaults if necessary
;-------------------------------------------------------------------------------
start_1:	ldi	YL,4
		ldi	YH,0
		libeep_read
		cpi	tempreg1,2
		brcs	start_1a
		cpi	tempreg1,6
		brcs	start_1e
start_1a:	ldi	YL,4
		ldi	YH,0
		ldi	tempreg1,HIGH(1000)
		libeep_write
		ldi	tempreg1,LOW(1000)
		libeep_write
start_1e:

;-------------------------------------------------------------------------------
; check calibration data for motor 2 and replace with defaults if necessary
;-------------------------------------------------------------------------------
start_2:	ldi	YL,6
		ldi	YH,0
		libeep_read
		cpi	tempreg1,2
		brcs	start_2a
		cpi	tempreg1,6
		brcs	start_2e
start_2a:	ldi	YL,6
		ldi	YH,0
		ldi	tempreg1,HIGH(1000)
		libeep_write
		ldi	tempreg1,LOW(1000)
		libeep_write
start_2e:

;-------------------------------------------------------------------------------
; copy calibraton data to RAM
;-------------------------------------------------------------------------------
start_3:	ldi	YL,4
		ldi	YH,0
		libeep_read
		sts	cal_mot1h,tempreg1
		libeep_read
		sts	cal_mot1l,tempreg1
		libeep_read
		sts	cal_mot2h,tempreg1
		libeep_read
		sts	cal_mot2l,tempreg1


;-------------------------------------------------------------------------------
; init sequence
;-------------------------------------------------------------------------------
		ldi	YL,1			;get current program
		ldi	YH,0
		libeep_read

		;init system variables
start_9:	andi	tempreg1,0x03		;limit to 4 programs
		sts	prog_num,tempreg1
		ldi	XL,0xff
		sts	channel_pwm,const_0
		sts	channel_pwm+1,const_0
		sts	channel_pwm+2,const_0
		sts	channel_pwm+3,const_0
		sts	channel_pwm+4,const_0
		sts	channel_pwm+5,const_0
		sts	channel_out,XL
		ldi	XL,0xff
		sts	tone_num,XL
		clr	variable
		sts	aux_var1,const_0
		sts	aux_var2,const_0

.if ctype == 8
;-------------------------------------------------------------------------------
;ATMega8 hardware init
;-------------------------------------------------------------------------------
		;timer 2 generates via CTC an 25,6KHz interrupt
		ldi	XL,0x0a
		out	TCCR2,XL
		ldi	XL,39
		out	OCR2,XL
		ldi	XL,0x80
		out	TIMSK,XL		;enable OC2 int

		;timer 1 is responsible for Servo-PWM
		ldi	XL,HIGH(20000)
		out	ICR1H,XL
		ldi	XL,LOW(20000)
		out	ICR1L,XL

		ldi	XL,LOW(500)
		ldi	XH,HIGH(500)
		movw	r0,XL

		;set zero value for motor 1
		lds	XH,cal_mot1h
		lds	XL,cal_mot1l
		add	XL,r0
		adc	XH,r1
		out	OCR1BH,XH
		out	OCR1BL,XL
		;set zero value for motor 2
		lds	XH,cal_mot2h
		lds	XL,cal_mot2l
		add	XL,r0
		adc	XH,r1
		out	OCR1AH,XH
		out	OCR1AL,XL

		;config timer 1
		ldi	XL,0xa2
		out	TCCR1A,XL
		ldi	XL,0x1A
		out	TCCR1B,XL
		sbi	DDRB,1
		sbi	DDRB,2
		out	PORTC,const_0
		ldi	XL,0x3f
		out	DDRC,XL
.else
;-------------------------------------------------------------------------------
;ATMega88 hardware init
;-------------------------------------------------------------------------------
		;timer 2 generates via CTC an 25,6KHz interrupt
		ldi	XL,0x0a
		sts	TCCR2A,XL
		ldi	XL,39
		sts	OCR2A,XL
		ldi	XL,0x02
		sts	TIMSK2,XL		;enable OC2 int
		;timer 1 generates Servo-PWM
		ldi	XL,HIGH(20000)
		sts	ICR1H,XL
		ldi	XL,LOW(20000)
		sts	ICR1L,XL

		ldi	XL,LOW(500)
		ldi	XH,HIGH(500)
		movw	r0,XL

		;set zero value for motor 1
		lds	XH,cal_mot1h
		lds	XL,cal_mot1l
		add	XL,r0
		adc	XH,r1
		sts	OCR1BH,XH
		sts	OCR1BL,XL
		;set zero value for motor 2
		lds	XH,cal_mot2h
		lds	XL,cal_mot2l
		add	XL,r0
		adc	XH,r1
		sts	OCR1AH,XH
		sts	OCR1AL,XL

		;config timer 1
		ldi	XL,0xa2
		sts	TCCR1A,XL
		ldi	XL,0x1A
		sts	TCCR1B,XL
		sbi	DDRB,1
		sbi	DDRB,2
		sts	PORTC,const_0
		ldi	XL,0x3f
		out	DDRC,XL

.endif

		;enable timer interrupt
		rcall	clr_segm		;clear all segment
		sei
		clr	tempreg3
		sbis	PINB,7			;skip if no start
		rjmp	calibrate		;calibrate servos if start button is pressed
		rcall	wait_nokey		;wait for no key press

;-------------------------------------------------------------------------------
; check autostart
;-------------------------------------------------------------------------------
		ldi	ZL,LOW(511)		;autostart program address in FLASH
		ldi	ZH,HIGH(511)
		lpm	tempreg1,Z
		cpi	tempreg1,0xff		;no valid autostart program
		breq	startloop

		lds	r0,autostart
		sbrs	r0,0
		rjmp	startloop		;was no POR

		andi	tempreg1,0x03
		sts	prog_num,tempreg1
		ldi	YL,1			;write default selected program
		ldi	YH,0
		libeep_write

		out	MCUSR,const_0		;clear POR bit
		rjmp	run			;run autostart program

startloop:	out	MCUSR,const_0		;clear POR bit
		ldi	XL,0x79
		mov	disp_d1,XL
		lds	r16,prog_num
		andi	r16,0x03
		inc	r16
		rcall	set_segm_num0
		rcall	wait_nokey

startloop_1:	sbis	PINB,7			;skip if no start
		rjmp	run			;start prog
		sbic	PINB,6			;skip if stop
		rjmp	startloop_1		;wait

		;count program up
		lds	r16,prog_num
		inc	r16
		andi	r16,0x03
		sts	prog_num,r16
		mov	tempreg1,r16
		ldi	YL,1			;get selected program
		ldi	YH,0
		libeep_write

		lds	r16,prog_num
		andi	r16,0x03
		inc	r16
		rcall	set_segm_num0

startloop_2:	rcall	wait_nokey
		rjmp	startloop_1


;-------------------------------------------------------------------------------
; wait for all keys released
;-------------------------------------------------------------------------------
wait_nokey:	ldi	XL,0
		ldi	XH,0
wait_nokey_1:	sbis	PINB,6			;skip if no stop
		rjmp	wait_nokey
		sbis	PINB,7			;skip if no start
		rjmp	wait_nokey
		sbiw	XL,1
		brne	wait_nokey_1
		ret


;-------------------------------------------------------------------------------
; calibrate servos
;-------------------------------------------------------------------------------
calibrate:	ldi	r16,0xca		;CA for calibration
		rcall	set_segm_hex
		sts	channel_out,const_0	;set all channels to input

cal_00:		ldi	variable,4		;assume setting of 4 (left)
		ldi	tempreg4,20
cal_01:		rcall	var_motor1
		rcall	var_motor2
		rcall	tune_motors
		dec	tempreg4
		brne	cal_01

		ldi	variable,5		;assume setting of 5 (no movement)
		ldi	tempreg4,20
cal_02:		rcall	var_motor1
		rcall	var_motor2
		rcall	tune_motors
		dec	tempreg4
		brne	cal_02

		ldi	variable,6		;assume setting of 6 (right)
		ldi	tempreg4,20
cal_03:		rcall	var_motor1
		rcall	var_motor2
		rcall	tune_motors
		dec	tempreg4
		brne	cal_03

		sbic	PINB,6			;skip if stop
		rjmp	cal_00			;do it again

		ldi	YL,4
		ldi	YH,0
		lds	tempreg1,cal_mot1h
		libeep_write
		lds	tempreg1,cal_mot1l
		libeep_write
		lds	tempreg1,cal_mot2h
		libeep_write
		lds	tempreg1,cal_mot2l
		libeep_write
		rcall	clr_segm		;clear display
		rcall	wait_nokey		;wait for key release
		rjmp	start			;restart system


;-------------------------------------------------------------------------------
; set motor offset values
;-------------------------------------------------------------------------------
tune_motors:	sbis	PINB,7			;start button -> coarse
		rjmp	tune_2
		mov	XL,tempreg4
		andi	XL,0x03
		brne	dec_m2_1

tune_2:

		;increment value for motor 1
		sbic	PINC,5			;1+
		rjmp	inc_m1_1

inc_m1:		lds	XH,cal_mot1h
		lds	XL,cal_mot1l
		adiw	XL,1
		cpi	XH,5
		brcc	inc_m1_1
		sts	cal_mot1h,XH
		sts	cal_mot1l,XL
inc_m1_1:

		;decrement value for motor 1
		sbic	PINC,4			;1-
		rjmp	dec_m1_1

dec_m1:		lds	XH,cal_mot1h
		lds	XL,cal_mot1l
		sbiw	XL,1
		cpi	XH,3
		brcs	dec_m1_1
		sts	cal_mot1h,XH
		sts	cal_mot1l,XL
dec_m1_1:


		;increment value for motor 2
		sbic	PINC,3			;2+
		rjmp	inc_m2_1

inc_m2:		lds	XH,cal_mot2h
		lds	XL,cal_mot2l
		adiw	XL,1
		cpi	XH,5
		brcc	inc_m2_1
		sts	cal_mot2h,XH
		sts	cal_mot2l,XL
inc_m2_1:

		;decrement value for motor 1
		sbic	PINC,2			;2-
		rjmp	dec_m2_1

dec_m2:		lds	XH,cal_mot2h
		lds	XL,cal_mot2l
		sbiw	XL,1
		cpi	XH,3
		brcs	dec_m2_1
		sts	cal_mot2h,XH
		sts	cal_mot2l,XL
dec_m2_1:
		ret				;OK, thats all



.include "interpreter.asm"
.include "int.asm"
.include "libs.inc"

.org 0xf00
segtable:
.include "segtab.inc"

.org 0xfc0
.include "memory.asm"
