#include "main.h"


void create_display(void)
{
	//comm and display field
	stat_widget = gtk_event_box_new();
	comm_widget = gtk_scrolled_window_new (NULL, NULL);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (comm_widget),
                                  GTK_POLICY_ALWAYS,
                                  GTK_POLICY_AUTOMATIC);

	comm_disp = gtk_drawing_area_new();
	comm_stat = gtk_drawing_area_new();

#if SIZE_TILE == 40
	gtk_widget_set_usize (stat_widget, 30, 320);
	gtk_widget_set_usize (comm_widget, 431, 320);
	gtk_drawing_area_size(GTK_DRAWING_AREA (comm_disp),810, 274);
	disp_draw = gdk_pixmap_new(window->window,810, 274, -1);
	stat_draw = gdk_pixmap_new(window->window,30, 320, -1);
	gdk_draw_rectangle(disp_draw,window->style->black_gc,TRUE,0,0,810,274);
	gdk_draw_rectangle(stat_draw,window->style->black_gc,TRUE,0,0,30,320);
#endif
#if SIZE_TILE == 60
	gtk_widget_set_usize (stat_widget, 43, 480);
	gtk_widget_set_usize (comm_widget, 632, 480);
	gtk_drawing_area_size(GTK_DRAWING_AREA (comm_disp),1210, 434);
	disp_draw = gdk_pixmap_new(window->window,1210, 434, -1);
	stat_draw = gdk_pixmap_new(window->window,43, 480, -1);
	gdk_draw_rectangle(disp_draw,window->style->black_gc,TRUE,0,0,1210,434);
	gdk_draw_rectangle(stat_draw,window->style->black_gc,TRUE,0,0,43,480);
#endif
	gtk_widget_show(comm_disp);
	gtk_widget_show(comm_stat);
	gtk_scrolled_window_add_with_viewport (GTK_SCROLLED_WINDOW (comm_widget), comm_disp);
	gtk_signal_connect(GTK_OBJECT (comm_disp),"expose_event",(GtkSignalFunc) expose_disp,NULL);
	gtk_signal_connect(GTK_OBJECT (comm_stat),"expose_event",(GtkSignalFunc) expose_stat,NULL);
	gtk_container_add(GTK_CONTAINER (stat_widget),comm_stat);
	gtk_container_set_border_width(GTK_CONTAINER (comm_widget),1);
	gtk_container_set_border_width(GTK_CONTAINER (stat_widget),1);
}

void init_display(void)
{
	GdkColor col_dblue = {128,0,0,0};
	GdkColor col_blue = {255,0,0,0};
	GdkGC *temp_gc =gdk_gc_new(disp_draw);
	int i,j;

#if SIZE_TILE == 40
	gdk_draw_rectangle(disp_draw,window->style->black_gc,TRUE,0,0,810,274);
	for(i=0;i<4;i++)
	{
		gdk_gc_set_foreground(temp_gc,&col_dblue);
		gdk_draw_rectangle(disp_draw,temp_gc,TRUE,5,15+65*i,800, 45);
		gdk_draw_pixmap(disp_draw,temp_gc,
		action_pixmap[21+i],
		0, 0,
		0, 2+65*i,
		120, 20);
		gdk_gc_set_foreground(temp_gc,&col_blue);
		gdk_draw_rectangle(disp_draw,temp_gc,FALSE,5,15+65*i,800, 45);
		gdk_draw_line(disp_draw,temp_gc,5,38+65*i,805,38+65*i);
		for(j=0;j<10;j++)
		{
			gdk_draw_line(disp_draw,temp_gc,5+80*j,15+65*i,5+80*j,60+65*i);
		}
	}

#endif
#if SIZE_TILE == 60
	gdk_draw_rectangle(disp_draw,window->style->black_gc,TRUE,0,0,1210,434);

	for(i=0;i<4;i++)
	{
		gdk_gc_set_foreground(temp_gc,&col_dblue);
		gdk_draw_rectangle(disp_draw,temp_gc,TRUE,5,22+106*i,1200, 76);
		gdk_draw_pixmap(disp_draw,temp_gc,
		action_pixmap[21+i],
		0, 0,
		0, 2+106*i,
		120, 20);
		gdk_gc_set_foreground(temp_gc,&col_blue);
		gdk_draw_rectangle(disp_draw,temp_gc,FALSE,5,22+106*i,1200, 76);
		gdk_draw_line(disp_draw,temp_gc,5,60+106*i,1205,60+106*i);
		for(j=0;j<10;j++)
		{
			gdk_draw_line(disp_draw,temp_gc,5+120*j,22+106*i,5+120*j,98+106*i);
		}
	}

#endif

	gtk_widget_queue_draw(comm_disp);
}

void redraw_display(void)
{
	GdkColor col_orange = {0xffa000,0,0,0};
	GdkGC *temp_gc =gdk_gc_new(disp_draw);
	int i,j,y,yp,xp,v_last,y_last,k;

#if SIZE_TILE == 40
	gdk_gc_set_foreground(temp_gc,&col_orange);
	for(i=0;i<4;i++) //channel
	{
		for(j=0;j<100;j++) //measure
		{
			y=channel_buffer[i][j];
			if((y < 21) && (y >=0))
			{
				yp=15+65*i+41-2*y;
				xp=6+8*j;
				gdk_draw_rectangle(disp_draw,temp_gc,TRUE,xp,yp,8,4);
				//draw a connection if more then 1 decrement
				if((y < (v_last-1)) && (j > 0) && (v_last < 21))
				{
					gdk_draw_line(disp_draw,temp_gc,
					xp-1,yp+3,xp-1,y_last);
					gdk_draw_line(disp_draw,temp_gc,
					xp,yp+3,xp,y_last);
				}
				//draw a connection if more then 1 increment
				if((y > (v_last+1)) && (j > 0) && (v_last < 21))
				{
					gdk_draw_line(disp_draw,temp_gc,
					xp-1,yp,xp-1,y_last+3);
					gdk_draw_line(disp_draw,temp_gc,
					xp,yp,xp,y_last+3);
				}
			}
			v_last=y;
			y_last=yp;
		}
	}

#endif
#if SIZE_TILE == 60
	gdk_gc_set_foreground(temp_gc,&col_orange);
	for(i=0;i<4;i++) //channel
	{
		for(j=0;j<100;j++) //measure
		{
			y=channel_buffer[i][j];
			if((y < 21) && (y >=0))
			{
				yp=22+106*i+70-3.5*y+0.5;
				xp=6+12*j;
				gdk_draw_rectangle(disp_draw,temp_gc,TRUE,xp,yp,12,7);
				//draw a connection if more then 1 decrement
				if((y < (v_last-1)) && (j > 0) && (v_last < 21))
				{
					gdk_draw_line(disp_draw,temp_gc,
					xp-1,yp+6,xp-1,y_last);
					gdk_draw_line(disp_draw,temp_gc,
					xp,yp+6,xp,y_last);
				}
				//draw a connection if more then 1 increment
				if((y > (v_last+1)) && (j > 0) && (v_last < 21))
				{
					gdk_draw_line(disp_draw,temp_gc,
					xp-1,yp,xp-1,y_last+6);
					gdk_draw_line(disp_draw,temp_gc,
					xp,yp,xp,y_last+6);
				}
			}
			v_last=y;
			y_last=yp;
		}
	}

#endif

	gtk_widget_queue_draw(comm_disp);
}


void redraw_stat(void)
{
	GdkColor col_dblue = {128,0,0,0};
	GdkColor col_red = {0xff0000,0,0,0};
	GdkGC *temp_gc =gdk_gc_new(stat_draw);
	int i,j,k;

#if SIZE_TILE == 40
	for(i=0;i<4;i++)
	{
		if(k==0) 
		{
			j=0;
		}
		else
		{
			j=channel_buffer[i][k-1];
		}
		if(j<0) j=0;
		if(j>20) j=20;
		gdk_gc_set_foreground(temp_gc,&col_dblue);
		gdk_draw_pixmap(stat_draw,temp_gc,
		cval_pixmap[j],
		0, 0,
		0, 26+65*i,
		30, 30);
	}
	if(sercom >= 0)
	{
		gdk_draw_pixmap(stat_draw,temp_gc,
		step_pixmap[channel_pointer],
		0, 0,
		0, 290,
		30, 30);
	}
	else
	{
		gdk_gc_set_foreground(temp_gc,&col_red);
		gdk_draw_rectangle(stat_draw,temp_gc,TRUE,0,286,30,30);
	}

#endif
#if SIZE_TILE == 60
	for(i=0;i<4;i++)
	{
		k=channel_pointer;
		if(k==0) 
		{
			j=0;
		}
		else
		{
			j=channel_buffer[i][k-1];
		}
		if(j<0) j=0;
		if(j>20) j=20;
		gdk_gc_set_foreground(temp_gc,&col_dblue);
		gdk_draw_pixmap(stat_draw,temp_gc,
		cval_pixmap[j],
		0, 0,
		1, 42+106*i,
		43,43);
	}
	if(sercom >= 0)
	{
		gdk_draw_pixmap(stat_draw,temp_gc,
		step_pixmap[channel_pointer],
		0, 0,
		0, 437,
		43, 43);
	}
	else
	{
		gdk_gc_set_foreground(temp_gc,&col_red);
		gdk_draw_rectangle(stat_draw,temp_gc,TRUE,0,430,43,43);
	}

#endif
	gtk_widget_queue_draw(comm_stat);
}


